/**
 * Ce programme sert  montrer l'hritage en Java
 * Le cas de la redfinition de mthodes
 * @author Mohamed Lokbani 
 * @version 1.1
 */


/**
 * Classe de base: vehicule
 */

class vehicule {
    
    private double vitesse;
    private int nbre_passagers;
    
    /**
       constructeur
       @param v la vitesse du vhicule
       @param np nbre de passagers dans le vhicule
    */
    public vehicule(double v,int np) {
	vitesse = v;
	nbre_passagers = np;
    }
    /**
       pour afficher les membres private.
    */
    public void affiche() {
	System.out.println("vitesse: " + vitesse + " ; nbre_passagers: " + nbre_passagers);
    }
}

/**
 * Classe drive : avion
 * Hritage  partir de la classe de base : vehicule
 */
class avion extends vehicule {
    
    private int nbre_moteurs;
    
    /**
       constructeur
       @param nm le nombre de moteurs
       pour le constructeur de vhicule
       @param v la vitesse du vhicule
       @param np nbre de passagers dans le vhicule
    */
    
    public avion(int nm,double v,int np) {
	super(v,np); // appel au constructeur de vehicule
	nbre_moteurs = nm;
    }

    /**
       La mthode affiche de la classe de base sera masque par
       la mthode affiche suivante ...
       @see vehicule#affiche
     */
    public void affiche() {
	super.affiche(); // appel  la mthode affiche de la classe de base
	System.out.println("nbre de moteurs: " + nbre_moteurs);
    }
}


/**
 * Classe drive : moto
 * Hritage  partir de la classe de base : vehicule
 */

class moto extends vehicule {
    
    private double cylindree;
    
    /**
       constructeur
       @param cy la cylindre en cm3.
       pour le constructeur de vhicule
       @param v la vitesse du vhicule
       @param np nbre de passagers dans le vhicule
    */
    public moto(double cy,double v,int np) {
	super(v,np); // appel au constructeur de vehicule
	cylindree = cy;
    }

    /**
       La mthode affiche de la classe de base sera masque par
       la mthode affiche suivante ...
       @see vehicule#affiche
    */
    public void affiche() {
	super.affiche(); // appel  la mthode affiche de la classe de base
	System.out.println("La cylindre de la moto: " + cylindree);
    }
}

/**
 * classe de test point d'entre pour la
 * machine virtuelle.
 */


public class herred {
    
    public static void main(String [] args) {
	vehicule v = new vehicule(200.,300);
	v.affiche();
	avion boeing = new avion(4,200.,300);
	boeing.affiche();
	moto suzuki = new moto(1200.,200.,2);
	suzuki.affiche();
	System.exit(0);
    }
}	
